// LENS EFFECTS: GLOW COMPONENTS
// *****************************
// This scene illustrates the 8 different types of glows included
// with the Lens Effects Include File.  These are numbered from
// left to right, starting at the top-left corner, ie:
//
//     1   2   3   4
//     5   6   7   8
//
// Note that the glows have been scaled to 75% of normal size to
// fit them all in one image.

// CAMERA AND EFFECT OPTIONS
   #declare camera_location = <0, 0, -12>
   #declare camera_look_at = <0, 0, 0>
   #declare effect_scale = .75

   global_settings {max_trace_level 10}

// GLOW TYPE 1
   #declare glow_type = 1
   #declare effect_location = <-6, 2, 0> #include "LNSEFCTS.INC"

// GLOW TYPE 2
   #declare glow_type = 2
   #declare effect_location = <-2, 2, 0> #include "LNSEFCTS.INC"

// GLOW TYPE 3
   #declare glow_type = 3
   #declare effect_location = <2, 2, 0> #include "LNSEFCTS.INC"

// GLOW TYPE 4
   #declare glow_type = 4
   #declare effect_location = <6, 2, 0> #include "LNSEFCTS.INC"

// GLOW TYPE 5
   #declare glow_type = 5
   #declare effect_location = <-6, -2, 0> #include "LNSEFCTS.INC"

// GLOW TYPE 6
   #declare glow_type = 6
   #declare effect_location = <-2, -2, 0> #include "LNSEFCTS.INC"

// GLOW TYPE 7
   #declare glow_type = 7
   #declare effect_location = <2, -2, 0> #include "LNSEFCTS.INC"

// GLOW TYPE 8
   #declare glow_type = 8
   #declare effect_location = <6, -2, 0> #include "LNSEFCTS.INC"
