// kom_pccs.inc  ver. 0.1.0 ---  my color include file for POV-Ray
// A color include file for systematical color specification for POV-Ray
//
//   97/04/26    Copyright(C) by Komuro Hideki,  Tokyo,  Japan.
//   email:  kom@super.win.or.jp
//           http://www.win.or.jp/~a-kojima/indexe.html
//
//             ***************************************
//             ***  This include file is FREEWARE  ***
//             ***************************************
//
// Using this include file, you can specify colors with the combination of
// the keywords, which consist of 13 Hues and 9 Tones for chromatic colors,
// 3 Tones for achromatic color (gray).
//
// =======================================================================
//
// * ACHROMATIC colors
//   WHITE (W),  BLACK (Bk)
//
//   3 tone keywords for Gray are ...
//     light (lt),   medium (m),   dark (d)
//
// In order to specify "light gray", write script like below.
// ( "lightGray", "ltGy", "lightGy", "ltGray", "lightGrey", "ltGrey" )
// (  are all acceptable.                                            )
//
// (ex)  pigment{ color ltGy }
//
// * CHROMATIC colors
//
//   13 hue keywords are ...
//
//     Red               (R)
//     ReddishOrange     (RO)
//     Orange            (O)
//     YellowishOrange   (YO)
//     Yellow            (Y)
//     YellowGreen       (YG)
//     Green             (G)
//     BlueGreen         (BG)
//     GreenishBlue      (GB)
//     Blue              (B)
//     Violet            (V)
//     Purple            (P)
//     RedPurple         (RP)
//
//   9 tone keywords are ...
//
//     pale              (p)
//     light             (lt)
//     bright            (b)
//     vivid             (v)
//     deep              (dp)
//     dark              (dk)
//     dull              (d)
//     lightgrayish      (ltg)      "lightgreyish" is also OK.
//     grayish           (g)        "greyish" is also OK.
//
//
// In order to specify "bright red", write script like below.
// ("brightRed", "bR", "brightR", "bRed" are all acceptable.)
//
// (ex)  pigment{ color brightRed }
//
// =======================================================================
// We can also use colors.inc with kom_pccs.inc at the same time.
// There is no common color name among two files.
// NOTE:
//    Black is "BLACK" (or "Bk") in kom_pccs.inc, while "Black" in colors.inc.
//    White is "WHITE"  (or "W") in kom_pccs.inc, while "White" in colors.inc.
// =======================================================================
// The idea of this include file are based on "Practical Color Co-ordinate
// System (P.C.C.S.)" developed by Japan color research institute.
// In Japan, P.C.C.S. is often used for art education e.t.c.
// =======================================================================
// I also made an include file of Munsell color system for POV-Ray, but
// it is too large. So I'm wondering how to make it smaller.
// If you are interested in it, please visit my homepage.
// =======================================================================

#include "pccs_m.inc"
#include "pccs_s.inc"

