
//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// p4def_00.inc - Set all variables, then call "p4_main.inc".
//
// "Paul's Primitive POV People", or "P4".
//
// Created by: Paul T. Dawson
//             ptdawson@voicenet.com
//             http://www.voicenet.com/~ptdawson
//
//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// **** WARNING!!! DO NOT USE THIS FILE!!! ****
//
// Make copies, with different numbers (01, 02, 03...), and use them.
// This is the "original" template file.
//
//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// How to use this file:
//
//      1. Make a copy, and give it a name like p4def_77.inc.
//      2. Give values to all the following variables.
//      3. Create YOUR OWN scene file, with camera, lights, everything.
//      4. Declare a seed called P4_RAND in your scene file.
//      5. Include this file only.
//      6. This file will automatically include the "p4_main.inc" file.
//      7. It will return an object called "One_Person".
//      8. After your include statement, show the object!
//
//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Declare the *textures* for everything.

        #declare P4_Eye_Texture = texture { pigment { Blue } }
        #declare P4_Glasses_Texture = texture { pigment{Gray30} }
        #declare P4_Hair_Texture = texture { pigment { Yellow } }
        #declare P4_Hat_Texture = texture { pigment { NeonBlue } }
        #declare P4_Lip_Texture = texture { pigment { Red } }
        #declare P4_Shirt_Texture = texture { pigment { SpicyPink } }
        #declare P4_Shoe_Texture = texture { pigment { LimeGreen } }
        #declare P4_Shorts_Texture = texture { pigment { SteelBlue } }
        #declare P4_Skin_Texture = texture { pigment { Copper } }

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Now choose *types* of things. You will have to read the directions
// to see what numbers are legal here!

        #declare P4_Eye_Type = 1
        #declare P4_Glasses_Type = 0
        #declare P4_Hair_Type = 3
        #declare P4_Hand_Type = 2
        #declare P4_Hat_Type = 1
        #declare P4_Mouth_Type = 3
        #declare P4_Nose_Type = 1
        #declare P4_Shirt_Type = 2
        #declare P4_Shoe_Type = 2
        #declare P4_Shorts_Type = 2

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Set the sizes of various things.

        #declare P4_Leg_Length = 30
        #declare P4_Neck_Height = 3
        #declare P4_Shirt_Height = 24
        #declare P4_Shorts_Height = 8

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Choose the rotation values. Please read the directions!

        #declare P4_Hat_Rotate = < 20, -40, 0 >
        #declare P4_Neck_Rotate = < 0, 0, 0 >
        #declare P4_Waist_Rotate = < -10, 0, 0 >

        #declare P4_Left_Hand_Rotate = < -40, 0, -40 >
        #declare P4_Right_Hand_Rotate = < 10, 0, 40 >

        #declare P4_Left_Elbow_Rotate = < 40, -110, 0 >
        #declare P4_Right_Elbow_Rotate = < 0, 70, 0 >

        #declare P4_Left_Eyelid_Rotate = -40
        #declare P4_Right_Eyelid_Rotate = -40

        #declare P4_Left_Knee_Rotate = < -20, 0, 0 >
        #declare P4_Right_Knee_Rotate = < -60, 20, 0 >

        #declare P4_Left_Leg_Rotate = < 20, 0, -5 >
        #declare P4_Right_Leg_Rotate = < 0, 0, 30 >

        #declare P4_Left_Shoulder_Rotate = < -60, -10, 30 >
        #declare P4_Right_Shoulder_Rotate = < -30, -20, -50 >

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Create the optional "holding" object. This will go into the left
// hand, and move with the hand. This is optional - just comment it
// out if not needed, and set the flag to "false".
//
// The flag is necessary to prevent person #2 from carrying the object
// that you gave to person #1. Set it to true or false.

        #declare P4_Holding_Flag = true

        #declare P4_Holding_Object =
                cylinder { <6,0,0><6,2,0>,6 pigment{Red} }

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Make another optional object - a "bracelet". This also has a flag
// to set on/off. This prevents duplicate bracelets! The bracelet
// should be at <0,0,0>, just like a standard torus.

        #declare P4_Bracelet_Flag = true

        #declare P4_Bracelet_Object =
                torus { 3, 1 pigment{Red} }

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Despite my attempts at using "realistic inches" as units, the
// people always seem to end up 8 or 9 feet tall. This variable lets
// you scale the person down to a normal size. Use the P4_TEST.POV
// scene to see how tall your person actually is!

        #declare P4_Total_Scale = 80/100

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// This is the height to move the person up, so his/her feet are on
// the floor. Sorry, but because of bendable legs, this has to be
// adjusted manually (by YOU). 8-)

        #declare P4_Y_Adjust = 32.5

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Now call "p4_main.inc" to create the object.

        #include "p4_main.inc"

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// End of this file.

