
//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// p4def_04.inc - Woman clipping shrubs.
//
// "Paul's Primitive POV People", or "P4".
//
// Created by: Paul T. Dawson
//             ptdawson@voicenet.com
//             http://www.voicenet.com/~ptdawson
//
//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Declare the *textures* for everything.

        #declare P4_Eye_Texture = texture { pigment { Blue } }
        #declare P4_Glasses_Texture = texture { pigment{Gray30} }
        #declare P4_Hair_Texture = texture { pigment { SemiSweetChoc } }
        #declare P4_Hat_Texture = texture { pigment { Gray80 } }

        #declare P4_Shirt_Texture =
                texture { pigment { checker Black, Yellow
                scale<100,3,100> translate <50,1,50> } }

        #declare P4_Shoe_Texture = texture { pigment { Orange } }

        #declare P4_Shorts_Texture =
        texture { pigment { Orange } normal { crackle 1 scale 0.3 } }

        #declare P4_Skin_Texture = texture { pigment { Copper } }

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Now choose *types* of things. You will have to read the directions
// to see what numbers are legal here!

        #declare P4_Eye_Type = 1
        #declare P4_Glasses_Type = 0
        #declare P4_Hair_Type = 3
        #declare P4_Hand_Type = 1
        #declare P4_Hat_Type = 5
        #declare P4_Mouth_Type = 3
        #declare P4_Nose_Type = 1
        #declare P4_Shirt_Type = 2
        #declare P4_Shoe_Type = 3
        #declare P4_Shorts_Type = 1

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Set the sizes of various things.

        #declare P4_Leg_Length = 34
        #declare P4_Neck_Height = 3
        #declare P4_Shirt_Height = 24
        #declare P4_Shorts_Height = 14

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Choose the rotation values. Please read the directions!

        #declare P4_Hat_Rotate = < 10, 0, 0 >
        #declare P4_Neck_Rotate = < -5, 0, 0 >
        #declare P4_Waist_Rotate = < -20, 0, 0 >

        #declare P4_Left_Elbow_Rotate = < 0, -90, 0 >
        #declare P4_Right_Elbow_Rotate = < 0, 100, 0 >

        #declare P4_Left_Eyelid_Rotate = -40
        #declare P4_Right_Eyelid_Rotate = -40

        #declare P4_Left_Knee_Rotate = < -5, 0, 0 >
        #declare P4_Right_Knee_Rotate = < -5, 0, 0 >

        #declare P4_Left_Leg_Rotate = < 5, 0, -5 >
        #declare P4_Right_Leg_Rotate = < 5, 0, 5 >

        #declare P4_Left_Shoulder_Rotate = < -40, -40, 30 >
        #declare P4_Right_Shoulder_Rotate = < -35, 60, -40 >

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Create the optional "holding" object. This will go into the left
// hand, and move with the hand. This is optional - just comment it
// out if not needed, and set the flag to "false".
//
// The flag is necessary to prevent person #2 from carrying the object
// that you gave to person #1. Set it to true or false.

        #declare P4_Holding_Flag = true

        #declare P4_Holding_Object = union {

                cylinder { <0,0,0><0,8,0>, 1 pigment{Red} }
                box { <-1,8,-0.25><1,24,0.25> pigment{Silver} }

                union {
                cylinder { <0,0,0><0,8,0>, 1 pigment{Red} }
                box { <-1,8,-0.25><1,24,0.25> pigment{Silver} }
                        translate y * -10
                        rotate z * 50
                        translate y * 10
                } // End of union.

                // Swing the clippers around so they end up
                // parallel with the ground.
                        //rotate y * 40
                        rotate x * -45

                } // End of union.

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Make another optional object - a "bracelet". This also has a flag
// to set on/off. This prevents duplicate bracelets! The bracelet
// should be at <0,0,0>, just like a standard torus.

        #declare P4_Bracelet_Flag = false

        #declare P4_Bracelet_Object =
                torus { 3, 1 pigment{Red} }

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Despite my attempts at using "realistic inches" as units, the
// people always seem to end up 8 or 9 feet tall. This variable lets
// you scale the person down to a normal size. Use the P4_TEST.POV
// scene to see how tall your person actually is!

        #declare P4_Total_Scale = 80/100

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// This is the height to move the person up, so his/her feet are on
// the floor. Sorry, but because of bendable legs, this has to be
// adjusted manually (by YOU). 8-)

        #declare P4_Y_Adjust = 32

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Now call "p4_main.inc" to create the object.

        #include "p4_main.inc"

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// End of this file.

