
//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// "sample-1.pov" - Sample tree for the "ptd_tree" include file.
//
// This is the fancy one!
//
//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Set up a simple scene.

        #include "colors.inc"
        #include "textures.inc"
        #include "skies.inc"
        #include "golds.inc"
        #include "stones.inc"
        #include "glass.inc"

        #default { finish { Shiny } }

        camera { location < 0, 6, -22> 
        look_at < 0, 9, 0> }

        light_source { < -100, 70, -100 > color rgb 2 }
        light_source { <    0, 10, -100 > color White shadowless }

        background { White }
        sky_sphere { S_Cloud1 rotate y * 180 }

        plane { y, 0
                pigment { color rgb < 0.5, 0.6, 0.2 > }
                normal { crackle 1 scale 1 } }

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Now set all of the variables for the tree. read "ptd_tree.txt" to
// find out what all these things do!

        #declare TREE_RAND = seed(0)
        #declare Wiggle_Flag = on
        #declare Branches_On_End_Flag = on

        #declare Number_Of_Large_Branches = 8
        #declare Number_Of_Medium_Branches = 8
        #declare Number_Of_Small_Branches = 8

        #declare Large_Branch_Minimum_Angle = 20
        #declare Large_Branch_Maximum_Angle = 80

        #declare Medium_Branch_Minimum_Angle = 20
        #declare Medium_Branch_Maximum_Angle = 80
        
        #declare Small_Branch_Minimum_Angle = 20
        #declare Small_Branch_Maximum_Angle = 80

        #declare Tree_Trunk_Size = 9

        #declare Large_Branch_Size_Min = 2
        #declare Large_Branch_Size_Max = 4

        #declare Medium_Branch_Size_Min = 2
        #declare Medium_Branch_Size_Max = 3

        #declare Small_Branch_Size_Min = 2
        #declare Small_Branch_Size_Max = 4

        #declare Leaf_Type = 5

        #declare TREE_MESH_SIZE = 200

        #declare Leaf_Texture = texture { T_Stone18 scale 0.5 }
        #declare Bark_Texture = texture { T_Stone14
                normal { bumps 2.0 scale 0.1 } }

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Now go and build the tree, then show it.

        #include "ptd_tree.inc"

        object { Complete_Tree rotate y * 180 }

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// End of this file.


