
//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// "sample-2.pov" - Sample tree for the "ptd_tree" include file.
//
// This is something like sample-1, but with simple leaves (spheres).
//
//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Set up a simple scene.

        #include "colors.inc"
        #include "textures.inc"
        #include "skies.inc"
        #include "golds.inc"
        #include "stones.inc"
        #include "glass.inc"

        #default { finish { Shiny } }

        camera { location < 0, 6, -22> 
        look_at < 0, 9, 0> }

        light_source { < -100, 100,    0 > color White}
        light_source { <    0, 100, -100 > color White}
        light_source { <  100, 100,    0 > color White}

        background { White }
        sky_sphere { S_Cloud2 }

        plane { y, 0  pigment { Coral } normal { crackle 1 scale 4 } }

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Now set all of the variables for the tree. read "ptd_tree.txt" to
// find out what all these things do!

        #declare TREE_RAND = seed(0)
        #declare Wiggle_Flag = on
        #declare Branches_On_End_Flag = on

        #declare Number_Of_Large_Branches = 5
        #declare Number_Of_Medium_Branches = 5
        #declare Number_Of_Small_Branches = 7

        #declare Large_Branch_Minimum_Angle = 20
        #declare Large_Branch_Maximum_Angle = 80

        #declare Medium_Branch_Minimum_Angle = 20
        #declare Medium_Branch_Maximum_Angle = 80
        
        #declare Small_Branch_Minimum_Angle = 20
        #declare Small_Branch_Maximum_Angle = 80

        #declare Tree_Trunk_Size = 8

        #declare Large_Branch_Size_Min = 3
        #declare Large_Branch_Size_Max = 5

        #declare Medium_Branch_Size_Min = 2
        #declare Medium_Branch_Size_Max = 4

        #declare Small_Branch_Size_Min = 2
        #declare Small_Branch_Size_Max = 4

        #declare Leaf_Type = 1

        #declare TREE_MESH_SIZE = 200

        #declare Leaf_Texture = texture { pigment { Red } }
        #declare Bark_Texture = texture { pigment { Yellow } }

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Now go and build the tree, then show it.

        #include "ptd_tree.inc"

        object { Complete_Tree }

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// End of this file.

