
//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// "sample-3.pov" - Sample tree for the "ptd_tree" include file.
//
// This is an extremely UNrealistic tree!
//
//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Set up a simple scene.

        #include "colors.inc"
        #include "textures.inc"
        #include "skies.inc"
        #include "golds.inc"
        #include "stones.inc"
        #include "glass.inc"

        #default { finish { Shiny } }

        camera { location < 0, 6, -22> 
        look_at < 0, 9, 0> }

        light_source { < -100, 100,    0 > color White}
        light_source { <    0, 100, -100 > color White}
        light_source { <  100, 100,    0 > color White}

        sky_sphere { S_Cloud2 rotate y*90 rotate x*90 }

        cylinder { <0,0,0><0,-1,0>,2000 texture { T_Green_Glass }
                normal { bumps 2 scale 4 } }
        
        cylinder { <0,-8,0><0,-9,0>,2000 pigment { Gray50 } }

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Now set all of the variables for the tree. read "ptd_tree.txt" to
// find out what all these things do!

        #declare TREE_RAND = seed(0)
        #declare Wiggle_Flag = off
        #declare Branches_On_End_Flag = on

        #declare Number_Of_Large_Branches = 13
        #declare Number_Of_Medium_Branches = 2
        #declare Number_Of_Small_Branches = 2

        #declare Large_Branch_Minimum_Angle = 70
        #declare Large_Branch_Maximum_Angle = 70
        
        #declare Medium_Branch_Minimum_Angle = 80
        #declare Medium_Branch_Maximum_Angle = 80
        
        #declare Small_Branch_Minimum_Angle = 90
        #declare Small_Branch_Maximum_Angle = 90

        #declare Tree_Trunk_Size = 7

        #declare Large_Branch_Size_Min = 7
        #declare Large_Branch_Size_Max = 7

        #declare Medium_Branch_Size_Min = 5
        #declare Medium_Branch_Size_Max = 5

        #declare Small_Branch_Size_Min = 1
        #declare Small_Branch_Size_Max = 1

        #declare Leaf_Type = 3

        #declare TREE_MESH_SIZE = 300

        #declare Leaf_Texture = texture { pigment { White } }
        #declare Bark_Texture = texture { T_Gold_3C }

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Now go and build the tree, then show it.

        #include "ptd_tree.inc"

        object { Complete_Tree }

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// End of this file.

