
//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// "sample-4.pov" - Sample tree for the "ptd_tree" include file.
//
// This demonstrates the use of Branches_On_End_Flag.
//
//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Set up a simple scene.

        #include "colors.inc"
        #include "textures.inc"
        #include "skies.inc"
        #include "golds.inc"
        #include "stones.inc"
        #include "glass.inc"

        #default { finish { Shiny } }

        camera { location < 0, 6, -15 > 
        look_at < 0, 9, 0> }

        light_source { < -100, 100,    0 > color White shadowless }
        light_source { <    0, 100, -100 > color White shadowless }
        light_source { <  100, 100,    0 > color White shadowless }

        background { White }

        sky_sphere { pigment { gradient y
                color_map { [0.0 color Red]
                            [0.5 color Yellow]
                            [1.0 color Green] } } }

        plane { y, 0  pigment { MediumAquamarine }  }

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Now set all of the variables for the tree. read "ptd_tree.txt" to
// find out what all these things do!

        #declare TREE_RAND = seed(0)
        #declare Wiggle_Flag = off
        #declare Branches_On_End_Flag = on

        #declare Number_Of_Large_Branches = 1
        #declare Number_Of_Medium_Branches = 1
        #declare Number_Of_Small_Branches = 15

        #declare Large_Branch_Minimum_Angle = 20
        #declare Large_Branch_Maximum_Angle = 20
        
        #declare Medium_Branch_Minimum_Angle = 40
        #declare Medium_Branch_Maximum_Angle = 40
        
        #declare Small_Branch_Minimum_Angle = 60
        #declare Small_Branch_Maximum_Angle = 60

        #declare Tree_Trunk_Size = 3

        #declare Large_Branch_Size_Min = 5
        #declare Large_Branch_Size_Max = 5

        #declare Medium_Branch_Size_Min = 4
        #declare Medium_Branch_Size_Max = 4

        #declare Small_Branch_Size_Min = 3
        #declare Small_Branch_Size_Max = 3

        #declare Leaf_Type = 1

        #declare TREE_MESH_SIZE = 300

        #declare Leaf_Texture = texture { pigment { Maroon } }
        #declare Bark_Texture = texture { T_Gold_1A }

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Now go and build the first tree, then show it.

        #include "ptd_tree.inc"

        object { Complete_Tree rotate y * -70 translate x * -1 }

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Now set all of the variables for the tree. read "ptd_tree.txt" to
// find out what all these things do!

        #declare TREE_RAND = seed(0)
        #declare Wiggle_Flag = off
        #declare Branches_On_End_Flag = off

        #declare Number_Of_Large_Branches = 1
        #declare Number_Of_Medium_Branches = 1
        #declare Number_Of_Small_Branches = 15

        #declare Large_Branch_Minimum_Angle = 20
        #declare Large_Branch_Maximum_Angle = 20
        
        #declare Medium_Branch_Minimum_Angle = 40
        #declare Medium_Branch_Maximum_Angle = 40
        
        #declare Small_Branch_Minimum_Angle = 60
        #declare Small_Branch_Maximum_Angle = 60

        #declare Tree_Trunk_Size = 3

        #declare Large_Branch_Size_Min = 5
        #declare Large_Branch_Size_Max = 5

        #declare Medium_Branch_Size_Min = 4
        #declare Medium_Branch_Size_Max = 4

        #declare Small_Branch_Size_Min = 3
        #declare Small_Branch_Size_Max = 3

        #declare Leaf_Type = 1

        #declare TREE_MESH_SIZE = 300

        #declare Leaf_Texture = texture { pigment { Maroon } }
        #declare Bark_Texture = texture { T_Gold_1A }

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// Now go and build the second tree, then show it.

        #include "ptd_tree.inc"

        object { Complete_Tree rotate y * -70 translate x * 5 }

//------------------------------------------------------------------->
//------------------------------------------------------------------->
//
// End of this file.

