// LENS EFFECTS: STREAK COMPONENTS
// *******************************
// This scene illustrates the 8 different types of streaks included
// with the Lens Effects Include File.  These are numbered from
// left to right, starting at the top-left corner, ie:
//
//     1   2   3   4
//     5   6   7   8
//
// Note that the streaks have been scaled to 30% of normal size to
// fit them all in one image.

// CAMERA AND EFFECT OPTIONS
   #declare camera_location = <0, 0, -12>
   #declare camera_look_at = <0, 0, 0>
   #declare effect_scale = .3

   global_settings {max_trace_level 10}

// STREAK TYPE 1
   #declare streak_type = 1
   #declare effect_location = <-6, 2, 0> #include "LNSEFCTS.INC"

// STREAK TYPE 2
   #declare streak_type = 2
   #declare effect_location = <-2, 2, 0> #include "LNSEFCTS.INC"

// STREAK TYPE 3
   #declare streak_type = 3
   #declare effect_location = <2, 2, 0> #include "LNSEFCTS.INC"

// STREAK TYPE 4
   #declare streak_type = 4
   #declare effect_location = <6, 2, 0> #include "LNSEFCTS.INC"

// STREAK TYPE 5
   #declare streak_type = 5
   #declare effect_location = <-6, -2, 0> #include "LNSEFCTS.INC"

// STREAK TYPE 6
   #declare streak_type = 6
   #declare effect_location = <-2, -2, 0> #include "LNSEFCTS.INC"

// STREAK TYPE 7
   #declare streak_type = 7
   #declare effect_location = <2, -2, 0> #include "LNSEFCTS.INC"

// STREAK TYPE 8
   #declare streak_type = 8
   #declare effect_location = <6, -2, 0> #include "LNSEFCTS.INC"
