// LnsFlare 3.0 demonstration file for POV-Ray 3.0
//
// By Nathan Kopp - August 26, 1997
//

#declare sky_vect = z
#declare cam_loc = <0,0,-5>
#declare lookat = <0,5,0>

camera {  //  Camera StdCam
  location  cam_loc
  direction <0.0,     0.0,  1.04>
  sky       sky_vect   // Use right handed-system!
  up        <0.0,     0.0,  1.0>  // Where Z is up
  right     <1.33333, 0.0,  0.0>
  look_at   lookat
}

#max_trace_level 30

#declare light_loc = <5,7,5>
#include "space3.flr"

#declare planet_loc = <0,5,0>
#declare planet_rad = 2
#declare light_rad = .5

#include "nkflare.inc"

light_source {   // Light1
  (light_loc+cam_loc) / 2
  color rgb <1.000, 1.000, 1.000>
}

// ********  OBJECTS  *******


sphere {
   <0,0,0>, 1
   pigment {
      bozo
      colour_map {
         [.7   colour rgb <0, .11, .67>   ]
         [.7   colour rgb <0, .4, 0>      ]
         [.999 colour rgb <.4, .53, .0>   ]
         [1.01 colour rgb <.53, .11, .11> ]
         }
      turbulence .5
      scale 1/3
      translate 100*x
      }
   scale 2
   translate <0,5,0>
   }

sphere {
   <0,0,0>, 1
   pigment {
      bozo
      colour_map { [0 colour rgbf 1]
                   [.4 colour rgbf 1]
                   [.9 colour rgb 1 ] }
      turbulence 1.0
      scale <12/30, 3/30, 12/30>
      rotate <30, 0, -45>
      }
   scale 2.05
   translate <0,5,0>
   }
