// c1997 by Stephan Kuhagen
// stk@informatik.uni-bremen.de
// mail me, send postcards, show me your pictures

/* Some sample-shapes, that makes usable leafs for trees. */


// Very simple, only a polygon with a stick

#declare LEAFSHAPE_00 =
union{
  polygon
  {
    13
    <-1,0,0>,
    <-0.5, 0, 0>
    <0, 0.3, 0>
    <0.5, 0, 0>
    <1,0,0>,
    <0.5,1,0>,
    <1,2,0>,
    <0.3,2,0>, 
    <0,3,0>,
    <-0.3,2,0>,
    <-1,2,0>,
    <-0.5,1,0>,
    <-1,0,0>
  }
  cone
  {
    <0, 0.3, 0>, 0.04, <0, -1, 0>, 0.07
  }
  translate <0, 1, 0>
}


// a mesh, similar to LEAFSHAPE_00, but not as flat as LEAFSHAPE_00

#declare LEAFSHAPE_01 =
union{
  mesh
  {
    triangle { < 0.0, 3.0,-0.3>,  <-1.0, 1.5, 0.0>,  < 0.0, 1.5,-0.2> }
    triangle { <-1.0, 1.5, 0.0>,  <-2.0, 1.0,-0.1>,  <-1.0, 0.5,-0.1> }
    triangle { <-2.0, 1.0,-0.1>,  <-2.5, 0.5,-0.2>,  <-2.0, 0.0, 0.0> }
    triangle { <-2.0, 1.0,-0.1>,  <-2.0, 0.0, 0.0>,  <-1.0, 0.5,-0.1> }
    triangle { <-1.0, 0.5,-0.1>,  <-2.0, 0.0, 0.0>,  <-1.0,-0.5, 0.0> }
    triangle { < 0.0, 1.5,-0.2>,  <-1.0, 1.5, 0.0>,  <-1.0, 0.5,-0.1> }
    triangle { < 0.0, 1.5,-0.2>,  <-1.0, 0.5,-0.1>,  < 0.0, 0.5,-0.1> }
    triangle { < 0.0, 0.5,-0.1>,  <-1.0, 0.5,-0.1>,  <-1.0,-0.5, 0.0> }
    triangle { < 0.0, 0.5,-0.1>,  <-1.0,-0.5, 0.0>,  < 0.0,-0.5,-0.1> }
    triangle { <-1.0,-0.5, 0.0>,  <-2.0,-1.5, 0.0>,  <-1.0,-1.5, 0.1> }
    triangle { <-1.0,-1.5, 0.1>,  <-2.0,-1.5, 0.0>,  <-1.5,-2.0,-0.1> }
    triangle { <-1.0,-1.5, 0.1>,  <-1.5,-2.0,-0.1>,  <-1.0,-2.0, 0.1> }
    triangle { <-1.0,-2.0, 0.1>,  <-1.5,-2.0,-0.1>,  <-0.5,-2.5,-0.2> }
    triangle { < 0.0,-2.0,-0.2>,  <-1.0,-2.0, 0.1>,  <-0.5,-2.5,-0.2> }
    triangle { < 0.0,-0.5,-0.1>,  <-1.0,-0.5, 0.0>,  <-1.0,-2.0, 0.1> }
    triangle { < 0.0,-0.5,-0.1>,  <-1.0,-2.0, 0.1>,  < 0.0,-2.0,-0.2> }
    
    triangle { <-0.0, 3.0,-0.3>,  < 1.0, 1.5, 0.0>,  <-0.0, 1.5,-0.2> }
    triangle { < 1.0, 1.5, 0.0>,  < 2.0, 1.0,-0.1>,  < 1.0, 0.5,-0.1> }
    triangle { < 2.0, 1.0,-0.1>,  < 2.5, 0.5,-0.2>,  < 2.0, 0.0, 0.0> }
    triangle { < 2.0, 1.0,-0.1>,  < 2.0, 0.0, 0.0>,  < 1.0, 0.5,-0.1> }
    triangle { < 1.0, 0.5,-0.1>,  < 2.0, 0.0, 0.0>,  < 1.0,-0.5, 0.0> }
    triangle { <-0.0, 1.5,-0.2>,  < 1.0, 1.5, 0.0>,  < 1.0, 0.5,-0.1> }
    triangle { <-0.0, 1.5,-0.2>,  < 1.0, 0.5,-0.1>,  <-0.0, 0.5,-0.1> }
    triangle { <-0.0, 0.5,-0.1>,  < 1.0, 0.5,-0.1>,  < 1.0,-0.5, 0.0> }
    triangle { <-0.0, 0.5,-0.1>,  < 1.0,-0.5, 0.0>,  <-0.0,-0.5,-0.1> }
    triangle { < 1.0,-0.5, 0.0>,  < 2.0,-1.5, 0.0>,  < 1.0,-1.5, 0.1> }
    triangle { < 1.0,-1.5, 0.1>,  < 2.0,-1.5, 0.0>,  < 1.5,-2.0,-0.1> }
    triangle { < 1.0,-1.5, 0.1>,  < 1.5,-2.0,-0.1>,  < 1.0,-2.0, 0.1> }
    triangle { < 1.0,-2.0, 0.1>,  < 1.5,-2.0,-0.1>,  < 0.5,-2.5,-0.2> }
    triangle { <-0.0,-2.0,-0.2>,  < 1.0,-2.0, 0.1>,  < 0.5,-2.5,-0.2> }
    triangle { <-0.0,-0.5,-0.1>,  < 1.0,-0.5, 0.0>,  < 1.0,-2.0, 0.1> }
    triangle { <-0.0,-0.5,-0.1>,  < 1.0,-2.0, 0.1>,  <-0.0,-2.0,-0.2> }
    
  }
  cone
  {
    <0, -2, -0.2>, 0.07, <0, -3.5, 0>, 0.1
  }
  translate <0, 3.5, 0>
}
