#include "colors.inc"
#include "skies.inc"
#include "stones.inc"
#include "leafshapes.inc"

#global_settings
{
 assumed_gamma 1.0
}

light_source { <0 , 300, 200> color White }

camera {
  up y
  right 4/3*x
  direction 2*z
  location <0 , 20, 100>
  look_at  <0 , 20, 0>
}


// declare some variables

#declare OBJECTNAME="mytree"
#declare RADIUS="1.1"
#declare TRUNKBASER="1.6"
#declare TRUNKCAPR="1.1"
#declare LDIFF="1"
#declare RADSCALE="0.6"
#declare RDIFF="0.3"
#declare RECSCALE="0.8"
#declare SLOPEANGLE="30"
#declare SANGLEDIFF="20"
#declare ANGLESCALE="1.1"
#declare NRBDIFF="0"
#declare RANDINIT_ROT="87657653"
#declare NRBSCALEADD="-0.5"
#declare BRANCHTOP="0.4"
#declare DEPTH= 8
#declare NRBRANCHES="sqrt(X+1)+2"
#declare USESTDTRUNK="YES"
#declare TRUNKLEN="12"

#declare LEAFINC = "YES"
#declare NRLEAFINCS = 1
#declare NRLEAFS = "3"

#declare LEAFINC_0 =
object {
   LEAF_SUMMER_03
}

#declare MOD_TR = 
texture { 
   pigment { color VeryDarkBrown }
   normal { crackle 1.6 scale <0.05, 0.2, 0.10> }
   finish { ambient 0.34 }
}

#declare MOD_0 =
texture { 
   pigment { color VeryDarkBrown }
   normal { crackle 1.6 scale <0.05, 0.2, 0.10> }
   finish { ambient 0.34 }
}

#declare MOD_1 =
texture { 
   MOD_0
}

#declare MOD_2 =
texture { 
   MOD_0
}

#declare MOD_3 =
texture {
   MOD_0
}

#declare MOD_4 =
texture { 
   MOD_0
}

#declare MOD_5 =
texture { 
   pigment { color VeryDarkBrown }
   normal { crackle 1 scale <0.05, 0.2, 0.10> }
   finish { ambient 0.34 }
}

#declare MOD_6 =
texture { 
   MOD_5
}

#declare MOD_7 =
texture { 
   pigment { color VeryDarkBrown }
   normal { crackle 0.5 scale <0.05, 0.2, 0.10> }
   finish { ambient 0.34 }
}


// now the cool trick... 

#include "selftree.inc"
#include "example.inc"

// and here's the tree

object {
   mytree
   rotate <0, 90, 0>
}



// a kind of moss

plane 
{
   <0,1,0>,0.02
   texture
   {
      T_Grnt23a
      scale 3
      normal { bumps 1.8 scale 2 }
      finish { reflection 0 }
   }
}
plane 
{
   <0,1,0>,0
   pigment {color Green }
}



// the sky 

background{color NewMidnightBlue}

object {
   O_Cloud1
   rotate <0, 180, 0>
}

