// c1997 by Stephan Kuhagen
// stk@informatik.uni-bremen.de
// mail me, send postcards, show me your pictures

#include "colors.inc"
#include "leafshapes.inc"

light_source { <100 , 50, 100> color White }


camera
{
 location <0 , 0, 51>
 look_at  <0 , 17, 0>
}

#declare LEAFINC_0 =
object
{
  LEAFSHAPE_01
  texture{
    pigment{ bozo
      color_map {
        [0 color rgb <.25,0,0>]
        [1 color rgb <0,1,0>]
      }
      scale 0.025
    }
    finish{
      ambient 0.2
      diffuse 0.8
      specular 0.6
    }
    normal{bozo 0.1
      scale 0.05
    }
  }
  scale 0.3
}

#declare LEAFINC_1 =
object
{
  LEAFSHAPE_01
  texture{
    pigment{ bozo
      color_map {
        [0 color rgb <.25,0.6,0>]
        [1 color rgb <0.3,0.8,0>]
      }
      scale 0.025
    }
    finish{
      ambient 0.2
      diffuse 0.8
      specular 0.6
    }
    normal{bozo 0.1
      scale 0.05
    }
  }
  scale 0.3
}

#declare LEAFINC_2 =
object
{
  LEAFSHAPE_01
  texture{
    pigment{ bozo
      color_map {
        [0 color rgb <.25,0,0>]
        [1 color rgb <1,0.6,0>]
      }
      scale 0.025
    }
    finish{
      ambient 0.2
      diffuse 0.8
      specular 0.6
    }
    normal{bozo 0.1
      scale 0.05
    }
  }
  scale 0.4
}


#declare MOD_TR = texture { pigment { color VeryDarkBrown } }
#declare MOD_0  = texture { pigment { color DarkBrown } normal { bozo 0.2 scale <0.05, 0.2, 0.08> } }
#declare MOD_1  = texture { pigment { color DarkBrown } normal { bozo 0.2 scale <0.05, 0.2, 0.08> } }
#declare MOD_2  = texture { pigment { color DarkBrown } normal { bozo 0.2 scale <0.05, 0.2, 0.08> } }
#declare MOD_3  = texture { pigment { color DarkBrown } normal { bozo 0.2 scale <0.05, 0.2, 0.08> } }
#declare MOD_4  = texture { pigment { color DarkBrown } normal { bozo 0.2 scale <0.05, 0.2, 0.08> } }
#declare MOD_5  = texture { pigment { color DarkBrown } normal { bozo 0.2 scale <0.05, 0.2, 0.08> } }
#declare MOD_6  = texture { pigment { color DarkBrown } normal { bozo 0.2 scale <0.05, 0.2, 0.08> } }
#declare MOD_7  = texture { pigment { color DarkBrown } normal { bozo 0.2 scale <0.05, 0.2, 0.08> } }
#declare MOD_8  = texture { pigment { color DarkBrown } normal { bozo 0.2 scale <0.05, 0.2, 0.08> } }


#declare BLEN=8
#declare RADIUS=1.1
#declare TRUNKBASER=1.6
#declare TRUNKCAPR=1.1
#declare LDIFF=1
#declare RADSCALE=0.7
#declare RDIFF=0.3
#declare RECSCALE=0.8
#declare SLOPEANGLE=50
#declare SANGLEDIFF=10
#declare ANGLESCALE=1
#declare NRBDIFF=1
#declare NRBSCALEADD=0
#declare BRANCHTOP=0.4
#declare DEPTH=8
#declare NRBRANCHES="(pow(((X/2)-2),2)/2.0)+1"
#declare USESTDTRUNK="YES"
#declare TRUNKLEN=14

#declare LEAFINC = "YES"
#declare NRLEAFINCS = 3
#declare NRLEAFS = 3

#include "selftree.inc"
#include "tree1.inc"


#debug    "\n\nSELFTREE STATISTICS:\n"
#debug        "--------------------\n"
#debug concat("Number of cones   : ",str(NROFCONES, 0, 0),"\n")
#debug concat("Number of spheres : ",str(NROFSPHERES, 0, 0),"\n")
#debug concat("Number of leafs   : ",str(NROFLEAFS, 0, 0),"\n")
